static char * sccsid = "@(#)  _init_db.c  (v2.8 3/27/90)";

/*
 * Initialize a kef_db structure.
 */

# include <stdio.h>
# include <sys/types.h>
# include <sys/times.h>
# include "kef.h"

	int
kef__init_db (kdb, nd, num_nodes, my_malloc, my_realloc, my_free)
	struct kef_db * kdb;
	struct kef_node * nd;
	int num_nodes;
	char * (* my_malloc) ();
	char * (* my_realloc) ();
	FREE_TYPE (* my_free) ();
/*
 * kdb and nd have been allocated. Set the initial values
 * in kdb accordingly.
 * The topmost node is allocated here.
 *
 * Returns: possible errors : none.
 */
{
	kdb->node = nd;
	kdb->num_nodes  = num_nodes;
	kdb->used_nodes = 1;
	kdb->high_nodes = 1;

	kdb->root = 0;
	kdb->free_list = KEF_NIL;

	kdb->longest = 0;
	kdb->must_clean = 0;
	kdb->was_allocated = 0;

	kdb->malloc = my_malloc;
	kdb->realloc = my_realloc;
	kdb->free = my_free;
	/*
	 * Initialize topmost node.
	 */
	kdb->node[0].sub = KEF_NIL;
	kdb->node[0].next = KEF_NIL;
	kdb->node[0].value = 0;
	kdb->node[0].num = 0;
	kdb->node[0].tag = KEF_NIL;
	kdb->node[0].what = '\0';
	kdb->node[0].flags = 0;		/* all flags set to NO */

	return KEF_E_OK;
}
